<?php
include("common.inc");
function generateRoundRobinPairings($eerste, $laatste, $numperiods) {
	// ONLY EVEN NUMBERS
	// Generate the pairings for each round.
	$num_teams=$laatste-$eerste+1;
	for ($round = 1; $round < min($num_teams,$numperiods+1); $round++) {
		$players_done = array();
		// Pair each player except the last.
		$groep=1;
		for ($player = 1; $player < $num_teams; $player++) {
			if (!in_array($player, $players_done)) {
				// Select opponent.
				$opponent = $round - $player;
				if ($opponent < 0) {
					$opponent += $num_teams;
				} else {
					$opponent += 1;					
				}
				$tegenstander[$round][$eerste+$player-1]['opponent']=$eerste+$opponent-1;
				$tegenstander[$round][$eerste+$opponent-1]['opponent']=$eerste+$player-1;
				if ($opponent != $player) {
					// Choose role. 
					if (($player + $opponent) % 2 == 0 xor $player < $opponent) { 
						$tegenstander[$round][$eerste+$player-1]['role']=1;
						$tegenstander[$round][$eerste+$opponent-1]['role']=2;
					} else { 
						$tegenstander[$round][$eerste+$player-1]['role']=2;
						$tegenstander[$round][$eerste+$opponent-1]['role']=1;
					} 
					$players_done[] = $player;
					$players_done[] = $opponent;
					}
				}
			}
			// Pair the last player.
			if ($round % 2 == 0) {
				$opponent = ($round + $num_teams) / 2;
				$tegenstander[$round][$eerste+$player-1]['role']=1;
				$tegenstander[$round][$eerste+$opponent-1]['role']=2;
			} else {
				$opponent = ($round + 1) / 2;
				$tegenstander[$round][$eerste+$player-1]['role']=2;
				$tegenstander[$round][$eerste+$opponent-1]['role']=1;
			}
			$tegenstander[$round][$eerste+$player-1]['opponent']=$eerste+$opponent-1;
			$tegenstander[$round][$eerste+$opponent-1]['opponent']=$eerste+$player-1;
	}
	if ($numperiods>=$num_teams){
		//repeat
		for ($round=$num_teams; $round<=$numperiods; $round++){
			for ($player=$eerste; $player<=$laatste; $player++){
				//als men elkaar weer tegenkomt zijn de rollen omgedraaid	
				$tegenstander[$round][$player]['opponent']=$tegenstander[$round-$num_teams+1][$player]['opponent'];	
				$tegenstander[$round][$player]['role']=3-$tegenstander[$round-$num_teams+1][$player]['role'];				
			}
		}
	}
	return $tegenstander;
}
$aantalgroepen=$_REQUEST['aantalgroepen'];
if ($aantalgroepen>0){
	$numperiods=$_REQUEST['numperiods'];
	$groep[1][1]=$_REQUEST['eerste1'];
	$groep[1][2]=$_REQUEST['laatste1'];
	$groep[2][1]=$_REQUEST['eerste2'];
	$groep[2][2]=$_REQUEST['laatste2'];
	$groep[3][1]=$_REQUEST['eerste3'];
	$groep[3][2]=$_REQUEST['laatste3'];
	$groep[4][1]=$_REQUEST['eerste4'];
	$groep[4][2]=$_REQUEST['laatste4'];
	$groep[5][1]=$_REQUEST['eerste5'];
	$groep[5][2]=$_REQUEST['laatste5'];
	$groep[6][1]=$_REQUEST['eerste6'];
	$groep[6][2]=$_REQUEST['laatste6'];
	//tabel creeren
	$sql = "CREATE TABLE groupcomposition (ppnr int";
	for ($i=1;$i<=$numperiods; $i++){
		$sql .= ", opponent".$i." int, role".$i." int";
	}
	$sql .=")";
	$connection = @mysql_connect(HOST,ADMIN, WWOORD) or die(mysql_error()." updateTableConnectionError");
	$db = @mysql_select_db(DBNAME,$connection)or die(mysql_error());
	$result=@mysql_query($sql,$connection) or die("Couldn't execute query (bestaat tabel al?) ".$sql);
	
	for ($gr=1;$gr<=$aantalgroepen; $gr++){
		$indeling=generateRoundRobinPairings($groep[$gr][1], $groep[$gr][2],$numperiods);
		for ($player=$groep[$gr][1]; $player<=$groep[$gr][2];$player++){
			//wegschrijven, hier simpel in een aparte tabel
			$names="ppnr"; $values=$player;
			for ($i=1;$i<=$numperiods; $i++){
				$names .=", opponent".$i.", role".$i;
				$values .=", ".$indeling[$i][$player]['opponent'].", ".$indeling[$i][$player]['role'];					
			}
			$sql="INSERT INTO groupcomposition (".$names.") VALUES (".$values.")";
			$result=@mysql_query($sql,$connection) or die("Couldn't execute query ".$sql);						
		}
		
	}
	echo "gelukt! Zie phpmyadmin";
	exit();
}
?>
</head>
<body>
<H1 align="center">Group composition: run when you know the number of participants</H1><br>
 <form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
  <table width="100%" border="0" cellpadding="0">
	<tr>
		<td><div align="right"><strong>Number of periods</div></td>
		<td><INPUT type="text" name="numperiods"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Number of independent groups</div></td>
		<td><INPUT type="text" name="aantalgroepen"  value=""></td>
	</tr>
	<tr>
		<td colspan=2><div align="center"><strong>There should be an even number in every group!</div></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 1</div></td>
		<td>ppnr=<INPUT type="text" name="eerste1"  value=""> to (including) <INPUT type="text" name="laatste1"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 2</div></td>
		<td>ppnr=<INPUT type="text" name="eerste2"  value=""> to (including) <INPUT type="text" name="laatste2"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 3</div></td>
		<td>ppnr=<INPUT type="text" name="eerste3"  value=""> to (including) <INPUT type="text" name="laatste3"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 4</div></td>
		<td>ppnr=<INPUT type="text" name="eerste4"  value=""> to (including) <INPUT type="text" name="laatste4"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 5</div></td>
		<td>ppnr=<INPUT type="text" name="eerste5"  value=""> to (including) <INPUT type="text" name="laatste5"  value=""></td>
	</tr>
	<tr>
		<td><div align="right"><strong>Group 6</div></td>
		<td>ppnr=<INPUT type="text" name="eerste6"  value=""> to (including) <INPUT type="text" name="laatste6"  value=""></td>
	</tr>
	<tr>
		<td></td>
		<td><input name="verzend" type="submit" value="verzend"></td>
	</tr>
  </table>
  </form>

</table>
</DIV>
</body>
</html>

